
#include "eval.h"

#define MIN -5.12
#define MAX 5.12

// 5.12^2 * 3
#define MAXCONSTANT 80

#define DECODEMAX 512
#define PRECISION 100

#define BITSPERX 10


inline double functor(double *x)
{
    return (x[0]*x[0] + x[1]*x[1] + x[2]*x[2]);
}


double eval(POPULATION *p, IPTR pj) 
    /* Called from gen.c and init.c */
{
    decode(pj); 
    return MAXCONSTANT - functor(pj->x);
}

void decode(IPTR pj)
{
    binToDec(&(pj->chrom[0]), pj->x);
}


// Chromosome description
// x1 x2 x3
// Need 1024 bits, so 10 bits per x
// 30 bit chromosome length
// Decoder explores the chromosome in sets of 3
// The decoded value is subtracted from 512
// This gives us a value between 512 and -512 since the max decoded
// value is 1024.  This value is then divided by 100 to convert to
// the desired precision.

void binToDec(int *chrom, double *x)
{

    int i, j;
    double prod;

    for(i = 0; i < PROBLEMSIZE; ++i)
    {
        prod=0.0;
        for(j = 0; j < BITSPERX; ++j)
            prod += (chrom[i*BITSPERX+j] == 0 ? 0.0 : pow((double)2.0, (double) j));
        x[i] = (DECODEMAX - prod)/PRECISION;
    }
}

void decToBin(int ad, int *barray, int size)
{
    int i, t;

    t = ad;
    for(i = 0; i < size; ++i)
    {
        barray[i] = t%2;
        t = t/2;
    }
}

void printResults(POPULATION *p)
{
    IPTR tmp;

    // Print Results
    printf("\nMax Invidual: %f\n", p->max);
    tmp = &(p->op[p->maxi]);
    decode(tmp);
    printf("Xs:");
    for ( int i=0; i < PROBLEMSIZE; ++i )
    {
        printf(" %f", tmp->x[i]);
    }

    printf("\nMin Invidual: %f\n", p->min);
    tmp = &(p->op[p->mini]);
    decode(tmp);
    printf("Xs:");
    for ( int i=0; i < PROBLEMSIZE; ++i )
    {
        printf(" %f", tmp->x[i]);
    }
    printf("\n");
}
