
#include "eval.h"

#define MIN -2.048
#define MAX 2.048

#define X1 x[0]
#define X2 x[1]

#define SQ2(x) x*x

// 100((-2.048)^2 - 0)^2 + (1-(-2.048))^2
//#define MAXCONSTANT 1770
// 100((-2.048)^2 - -2.048)^2 + (1-(-2.048))^2
#define MAXCONSTANT 3906

#define DECODEMAX 2048
#define PRECISION 1000


inline double functor(double *x)
{
    return ( ( 100*( (x[0]*x[0]-x[1])*(x[0]*x[0]-x[1]) ) + (1-x[0])*(1-x[0]) ));
    //
    //return ( 100*SQ2(X1*X1-X2) + SQ2(1-X1) );
}


double eval(POPULATION *p, IPTR pj) 
    /* Called from gen.c and init.c */
{
    decode(pj); 
    //printf("%f %f %f\n", pj->x[0],pj->x[1],pj->x[2]);

    return MAXCONSTANT - functor(pj->x);
}

void decode(IPTR pj)
{
    binToDec(&(pj->chrom[0]), pj->x);
}


// Chromosome description
// x1 x2
// Need 4096 values, so 12 bits per x
// 24 bit chromosome length
// Decoder explores the chromosome in sets of 2
// The decoded value is subtracted from 2048
// This gives us a value between 2048 and -2048 since the max decoded
// value is 4096.  This value is then divided by 1000 to convert to
// the desired precision.

void binToDec(int *chrom, double *x)
{
    int i;
    double prod;

    prod=0.0;
    for(i = 0; i < 12; ++i)
        prod += (chrom[i] == 0 ? 0.0 : pow((double)2.0, (double) i));
    x[0] = (DECODEMAX - prod)/PRECISION;

    prod=0.0;
    for(i = 12; i < 24; ++i)
        prod += (chrom[i] == 0 ? 0.0 : pow((double)2.0, (double) i-12));
    x[1] = (DECODEMAX - prod)/PRECISION;
}

void decToBin(int ad, int *barray, int size)
{
    int i, t;

    t = ad;
    for(i = 0; i < size; ++i)
    {
        barray[i] = t%2;
        t = t/2;
    }
}
