#include <math.h>

#include "utils.h"
#include "eval.h"

void initialize(char *argv[], POPULATION *p);
void generation(POPULATION *p, int gen);
void report(int gen, POPULATION *p, IPTR  pop);
void statistics(POPULATION *p, IPTR pop);

int main(int argc, char *argv[])
{
    IPTR tmp, op, np;
    POPULATION population;
    POPULATION *p = &population;

    p->gen = 0;
    if(argc != 2) 
        erfunc("Usage: ga <inputfile name> ", argc);

    initialize(argv, p);

    while(p->gen < p->maxGen)
    {
        p->gen++;
        generation(p, p->gen);
        statistics(p, p->np);
        report(p->gen, p, p->np);
        tmp = p->op;
        p->op = p->np;
        p->np = tmp;
    }

    // Print Results
    printf("\nMax Invidual: %f\n", p->max);
    tmp = &(p->op[p->maxi]);
    for ( int i=0; i < p->lchrom; ++i )
    {
        printf("%d", tmp->chrom[i]);
        if ( i == 11 )
            printf("\n");
    }
    printf("\n");
    decode(tmp);
    printf("Xs: %f %f\n", tmp->x[0],tmp->x[1]);

    printf("\nMin Invidual: %f\n", p->min);
    tmp = &(p->op[p->mini]);
    for ( int i=0; i < p->lchrom; ++i )
    {
        printf("%d", tmp->chrom[i]);
        if ( i == 11 )
            printf("\n");
    }
    printf("\n");
    decode(tmp);
    printf("Xs: %f %f\n", tmp->x[0],tmp->x[1]);

    return 0;
}
