
#include "eval.h"

#define MIN -5.12
#define MAX  5.12

#define X1 x[0]
#define X2 x[1]

#define MAXCONSTANT 26

#define DECODEMAX 512
#define PRECISION 100


inline double functor(double *x)
{
    return (double)( int(x[0])+int(x[1])+int(x[2])+int(x[3])+int(x[4]) );
}


double eval(POPULATION *p, IPTR pj) 
    /* Called from gen.c and init.c */
{
    decode(pj); 
    return MAXCONSTANT - functor(pj->x);
}

void decode(IPTR pj)
{
    binToDec(&(pj->chrom[0]), pj->x);
}


// Chromosome description
// x1 x2 x3 x4 x5
// Need 1024 values, so 10 bits per x
// 50 bit chromosome length
// Decoder explores the chromosome in sets of 5
// The decoded value is subtracted from 512
// This gives us a value between 512 and -512 since the max decoded
// value is 1024.  This value is then divided by 100 to convert to
// the desired precision.

void binToDec(int *chrom, double *x)
{
    int i;
    double prod;

    prod=0.0;
    for(i = 0; i < 10; ++i)
        prod += (chrom[i] == 0 ? 0.0 : pow((double)2.0, (double) i));
    x[0] = (DECODEMAX - prod)/PRECISION;

    prod=0.0;
    for(i = 10; i < 20; ++i)
        prod += (chrom[i] == 0 ? 0.0 : pow((double)2.0, (double) i-10));
    x[1] = (DECODEMAX - prod)/PRECISION;

    prod=0.0;
    for(i = 20; i < 30; ++i)
        prod += (chrom[i] == 0 ? 0.0 : pow((double)2.0, (double) i-20));
    x[2] = (DECODEMAX - prod)/PRECISION;

    prod=0.0;
    for(i = 30; i < 40; ++i)
        prod += (chrom[i] == 0 ? 0.0 : pow((double)2.0, (double) i-30));
    x[3] = (DECODEMAX - prod)/PRECISION;

    prod=0.0;
    for(i = 40; i < 50; ++i)
        prod += (chrom[i] == 0 ? 0.0 : pow((double)2.0, (double) i-40));
    x[4] = (DECODEMAX - prod)/PRECISION;

}

void decToBin(int ad, int *barray, int size)
{
    int i, t;

    t = ad;
    for(i = 0; i < size; ++i)
    {
        barray[i] = t%2;
        t = t/2;
    }
}

void printResults(POPULATION *p)
{
    IPTR tmp;

    // Print Results
    printf("\nMax Invidual: %f\n", p->max);
    tmp = &(p->op[p->maxi]);
    for ( int i=0; i < p->lchrom; ++i )
    {
        printf("%d", tmp->chrom[i]);
        if ( i == 9 || i == 19 || i == 29 || i == 39)
            printf("\n");
    }
    printf("\n");
    decode(tmp);
    printf("Xs: %f %f %f %f %f\n", tmp->x[0],tmp->x[1],tmp->x[2],
            tmp->x[3],tmp->x[4]);

    printf("\nMin Invidual: %f\n", p->min);
    tmp = &(p->op[p->mini]);
    for ( int i=0; i < p->lchrom; ++i )
    {
        printf("%d", tmp->chrom[i]);
        if ( i == 9 || i == 19 || i == 29 || i == 39)
            printf("\n");
    }
    printf("\n");
    decode(tmp);
    printf("Xs: %f %f %f %f %f\n", tmp->x[0],tmp->x[1],tmp->x[2],
            tmp->x[3],tmp->x[4]);
}
