
#include "eval.h"

#define MIN -1.28
#define MAX  1.28

#define MAXCONSTANT 2000

#define DECODEMAX 128
#define PRECISION 100

#define BITSPERX 8
#define ONEOVERPI 0.39894228



inline double Gauss(double x)
{
    //double gauss = ONEOVERPI * exp((-x*x)/2.0); 
    return ONEOVERPI * exp((-x*x)/2.0); 
}


inline double functor(double *x)
{
    double sum=0.0;

    for ( int i=0; i < PROBLEMSIZE; ++i )
        sum += i*pow(x[i],4) + Gauss(x[i]);
        //sum += i*pow(x[i],4) + (rand()%100)/100.0;

    return sum;
}


double eval(POPULATION *p, IPTR pj) 
    /* Called from gen.c and init.c */
{
    decode(pj); 
    return MAXCONSTANT - functor(pj->x);
}

void decode(IPTR pj)
{
    binToDec(&(pj->chrom[0]), pj->x);
}


// Chromosome description
// x1 x2 ... x29 x30
// Need 256 values, so 8 bits per x -> 8*30 = 240
// 240 bit chromosome length
// Decoder explores the chromosome in sets of 30
// The decoded value is subtracted from 128
// This gives us a value between 128 and -128 since the max decoded
// value is 256.  This value is then divided by 100 to convert to
// the desired precision.

void binToDec(int *chrom, double *x)
{
    int i, j;
    double prod;

    for(i = 0; i < PROBLEMSIZE; ++i)
    {
        prod=0.0;
        for(j = 0; j < BITSPERX; ++j)
            prod += (chrom[i*BITSPERX+j] == 0 ? 0.0 : pow((double)2.0, (double) j));
        x[i] = (DECODEMAX - prod)/PRECISION;
    }
}

void decToBin(int ad, int *barray, int size)
{
    int i, t;

    t = ad;
    for(i = 0; i < size; ++i)
    {
        barray[i] = t%2;
        t = t/2;
    }
}

void printResults(POPULATION *p)
{
    IPTR tmp;

    // Print Results
    printf("\nMax Invidual: %f\n", p->max);
    tmp = &(p->op[p->maxi]);
    decode(tmp);
    printf("Xs:");
    for ( int i=0; i < PROBLEMSIZE; ++i )
    {
        printf(" %f", tmp->x[i]);
    }

    printf("\nMin Invidual: %f\n", p->min);
    tmp = &(p->op[p->mini]);
    decode(tmp);
    printf("Xs:");
    for ( int i=0; i < PROBLEMSIZE; ++i )
    {
        printf(" %f", tmp->x[i]);
    }
    printf("\n");
}
